function C  = mat_uni(I)

% Uniform pdf matrix
%
% Usage
% ------
%
% C = mat_uni(I);
%
% Inputs 
% ------
%
%
% I            Adjacency matrix (D x S)
%
% Output 
% ------
%
% C            Uniform pdf matrix (D x S);
%
%
% Example
% -------
%
% I = indice_ij(4 , 4);
% C = mat_random(I);
%
%
% Author          Sébastien PARIS (sebastien.paris@lsis.org)
% -------




[D , S]  = size(I);

Itemp    = I~=0;

sI       = sum(Itemp , 1);

cte      = ones(1 , S);

ind      = (sI ~= 0);

cte(ind) = 1./sI(ind);

C        = Itemp.*cte(ones(D , 1) , :);



